/*==========================================================================;
 *
 *  Copyright (C) 1995-2001 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       idirect3dbasetexture8.cpp
 *  Content:    Direct3D capabilities include file
 *
 ***************************************************************************/
#include "d3dprj.h"


BIDirect3DBaseTexture8::BIDirect3DBaseTexture8(IDirect3DDevice8 *pDevice) : m_pDevice(pDevice), m_refCount(0)
{
	APIDEBUG(NO API DEBUG FOR BASETEXTURE);	
}

ULONG
BIDirect3DBaseTexture8::AddRef()
{
	m_refCount++;
	return 0;
}

HRESULT 
BIDirect3DBaseTexture8::FreePrivateData(REFGUID refguid)
{
	return 0;
}

HRESULT
BIDirect3DBaseTexture8::GetDevice(IDirect3DDevice8 **ppDevice)
{
	m_pDevice->AddRef();
	*ppDevice = m_pDevice;
	return 0;
}

DWORD
BIDirect3DBaseTexture8::GetLevelCount()
{
	return 0;
}

DWORD
BIDirect3DBaseTexture8::GetLOD()
{
	return 0;
}

DWORD
BIDirect3DBaseTexture8::GetPriority()
{
	return 0;
}

HRESULT
BIDirect3DBaseTexture8::GetPrivateData(REFGUID refguid, void *pData, DWORD *pSizeOfData)
{
	return 0;
}

D3DRESOURCETYPE
BIDirect3DBaseTexture8::GetType()
{
	return D3DRTYPE_TEXTURE;
}

void
BIDirect3DBaseTexture8::PreLoad()
{
	return ;
}

HRESULT
BIDirect3DBaseTexture8::QueryInterface(REFIID, void **ppvObj)
{
	return 0;
}

ULONG
BIDirect3DBaseTexture8::Release()
{	
	m_refCount--;
	if (m_refCount < 0)
	{
		delete this;
	}
	return 0;
}

DWORD
BIDirect3DBaseTexture8::SetPriority(DWORD PriorityNew)
{
	return 0;
}

HRESULT
BIDirect3DBaseTexture8::SetPrivateData(REFGUID refguid, CONST void *pData, DWORD SizeOfData, DWORD Flags)
{
	return 0;
}

DWORD BIDirect3DBaseTexture8::SetLOD(DWORD LODNew)
{
	return 0;
}