/*==========================================================================;
 *
 *  Copyright (C) 1995-2001 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       idirect3dcubetexture8.cpp
 *  Content:    Direct3D capabilities include file
 *
 ***************************************************************************/
#include "d3dprj.h"

BIDirect3DCubeTexture8::BIDirect3DCubeTexture8(IDirect3DDevice8 *pDevice, UINT EdgeLength, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool) :
m_pDevice(pDevice), m_EdgeLength(EdgeLength), m_Levels(Levels), m_Usage(Usage), m_Format(Format), m_Pool(Pool),
m_Lod(0), m_Priority(0), m_refCount(0)
{
	APIDEBUG(NO API DEBUG FOR CUBETEXTURE);
}

HRESULT
BIDirect3DCubeTexture8::AddDirtyRect(D3DCUBEMAP_FACES FaceType, CONST RECT *pDirtyRect)
{
	return D3D_OK;
}

ULONG
BIDirect3DCubeTexture8::AddRef()
{
	m_refCount++;
	return D3D_OK;
}

HRESULT 
BIDirect3DCubeTexture8::FreePrivateData(REFGUID refguid)
{
	return D3D_OK;
}

HRESULT
BIDirect3DCubeTexture8::GetCubeMapSurface(D3DCUBEMAP_FACES FaceType, UINT Level , IDirect3DSurface8 **ppCubeMapSurface)
{
	return D3D_OK;
}


HRESULT
BIDirect3DCubeTexture8::GetDevice(IDirect3DDevice8 **ppDevice)
{
	m_pDevice->AddRef();
	*ppDevice = m_pDevice;
	return D3D_OK;
}

DWORD
BIDirect3DCubeTexture8::GetLevelCount()
{
	return m_Levels;
}

HRESULT
BIDirect3DCubeTexture8::GetLevelDesc(UINT Level, D3DSURFACE_DESC *pDesc)
{
	memset(pDesc, 0, sizeof(D3DSURFACE_DESC));
	pDesc->Format = m_Format;
	pDesc->Height = m_EdgeLength;
	pDesc->Width = m_EdgeLength;
	pDesc->Pool = m_Pool;
	pDesc->Usage = m_Usage;	
	return D3D_OK;
}

DWORD
BIDirect3DCubeTexture8::GetLOD()
{
	return m_Lod;
}

DWORD
BIDirect3DCubeTexture8::GetPriority()
{
	return m_Priority;
}

HRESULT
BIDirect3DCubeTexture8::GetPrivateData(REFGUID refguid, void *pData, DWORD *pSizeOfData)
{
	return D3D_OK;
}

D3DRESOURCETYPE
BIDirect3DCubeTexture8::GetType()
{
	return D3DRTYPE_CUBETEXTURE;
}

HRESULT
BIDirect3DCubeTexture8::LockRect(D3DCUBEMAP_FACES FaceType, UINT Level, D3DLOCKED_RECT *pLockedRect, CONST RECT *pRect, DWORD Flags)
{
	return D3D_OK;
}


void
BIDirect3DCubeTexture8::PreLoad()
{
	return ;
}

HRESULT
BIDirect3DCubeTexture8::QueryInterface(REFIID, void **ppvObj)
{
	return D3D_OK;
}

ULONG
BIDirect3DCubeTexture8::Release()
{
	m_refCount--;
	if ( m_refCount < 0 )
	{
		delete this;
	}	
	return D3D_OK;
}

DWORD
BIDirect3DCubeTexture8::SetLOD(DWORD LODNew)
{
	m_Lod = LODNew;
	return D3D_OK;
}

DWORD
BIDirect3DCubeTexture8::SetPriority(DWORD PriorityNew)
{
	m_Priority = PriorityNew;
	return D3D_OK;
}

HRESULT
BIDirect3DCubeTexture8::SetPrivateData(REFGUID refguid, CONST void *pData, DWORD SizeOfData, DWORD Flags)
{
	return D3D_OK;
}

HRESULT
BIDirect3DCubeTexture8::UnlockRect(D3DCUBEMAP_FACES FaceType, UINT Level)
{
	return D3D_OK;
}
