/*==========================================================================;
 *
 *  Copyright (C) 1995-2001 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       idirect3dindexbuffer8.cpp
 *  Content:    Direct3D capabilities include file
 *
 ***************************************************************************/
#include "d3dprj.h"

BIDirect3DIndexBuffer8::BIDirect3DIndexBuffer8(IDirect3DDevice8 *pDevice, UINT Length, DWORD Usage, DWORD FVF, D3DPOOL pool)
: m_pDevice(pDevice), m_Length(Length), m_Usage(Usage), m_FVF(FVF), m_pool(pool), m_Priority(0), m_refCount(0)
{
	APIDEBUG(NO API DEBUG FOR INDEXBUFFER);
	m_pIndex = new BYTE[Length];
}

ULONG BIDirect3DIndexBuffer8::AddRef()
{
	m_refCount++;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::FreePrivateData(REFGUID refguid)
{
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetDesc(D3DINDEXBUFFER_DESC *pDesc)
{

	pDesc->Pool = m_pool;
	pDesc->Size = m_Length;
	pDesc->Type = GetType();
	pDesc->Usage = m_Usage;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetDevice(IDirect3DDevice8 **pDevice)
{
	m_pDevice->AddRef();
	*pDevice = m_pDevice;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetPrivateData(REFGUID refguid, void *pData, DWORD *pSizeOfData)
{
	return 0;
}

D3DRESOURCETYPE BIDirect3DIndexBuffer8::GetType()
{
	return D3DRTYPE_INDEXBUFFER;
}

HRESULT BIDirect3DIndexBuffer8::Lock(UINT OffsetToLock, UINT SizeToLock, BYTE **ppbData, DWORD Flags)
{
	*ppbData = m_pIndex + OffsetToLock;
	return 0;
}

void BIDirect3DIndexBuffer8::PreLoad()
{
	return ;
}

HRESULT BIDirect3DIndexBuffer8::QueryInterface(REFIID riid, void **ppvObj)
{
	return 0;
}

ULONG BIDirect3DIndexBuffer8::Release()
{	
	m_refCount--;
	if (m_refCount < 0)
	{
		delete[] m_pIndex;
		delete this;
	}	
	return 0;
}

DWORD BIDirect3DIndexBuffer8::GetPriority()
{
	return m_Priority;
}

DWORD BIDirect3DIndexBuffer8::SetPriority(DWORD PriorityNew)
{
	m_Priority = PriorityNew;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::SetPrivateData(REFGUID refguid, CONST void *pData, DWORD SizeOfData, DWORD Flags)
{
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::Unlock()
{
	return 0;
}