/*==========================================================================;
 *
 *  Copyright (C) 1995-2001 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       idirect3dvolumetexture8.cpp
 *  Content:    Direct3D capabilities include file
 *
 ***************************************************************************/
#include "d3dprj.h"

//
BIDirect3DVolumeTexture8::BIDirect3DVolumeTexture8(IDirect3DDevice8 *pDevice, INT Width, UINT Height, UINT Depth, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool) :
m_pDevice(pDevice), m_Width(Width), m_Height(Height), m_Depth(Depth), m_Levels(Levels), m_Usage(Usage), m_Format(Format), m_Pool(Pool), m_refCount(0)
{
}

HRESULT BIDirect3DVolumeTexture8::FreePrivateData(REFGUID refguid)
{
	return D3D_OK;
}

HRESULT BIDirect3DVolumeTexture8::GetPrivateData(REFGUID refguid, void *pData, DWORD *pSizeOfData)
{
	return D3D_OK;
}

void BIDirect3DVolumeTexture8::PreLoad()
{
	return ;
}

HRESULT BIDirect3DVolumeTexture8::QueryInterface(REFIID riid, void **ppvObj)
{
	return D3D_OK;
}

ULONG BIDirect3DVolumeTexture8::Release()
{	
	if (!m_refCount)
	{
		delete this;
	}
	m_refCount--;
	return D3D_OK;
}

HRESULT BIDirect3DVolumeTexture8::SetPrivateData(REFGUID refguid, CONST void *pData, DWORD SizeOfData, DWORD Flags)
{
	return D3D_OK;
}
HRESULT
BIDirect3DVolumeTexture8::GetVolumeLevel(UINT Level, IDirect3DVolume8**ppVolume)
{
	return D3D_OK;
}

HRESULT
BIDirect3DVolumeTexture8::LockBox(UINT Level, D3DLOCKED_BOX *pLockedVolume, CONST D3DBOX *pBox, DWORD Flags)
{
	return D3D_OK;
}

HRESULT
BIDirect3DVolumeTexture8::UnlockBox(UINT Level)
{
	return D3D_OK;
}

HRESULT
BIDirect3DVolumeTexture8::AddDirtyBox(CONST D3DBOX *pDirtyBox)
{
	return D3D_OK;
}

DWORD
BIDirect3DVolumeTexture8::GetLOD()
{
	return m_Lod;
}

DWORD
BIDirect3DVolumeTexture8::GetPriority()
{
	return m_Priority;
}

DWORD
BIDirect3DVolumeTexture8::GetLevelCount()
{
	return this->m_Levels;
}

DWORD
BIDirect3DVolumeTexture8::SetLOD(DWORD Lodnew)
{
	m_Lod = Lodnew;
	return m_Lod;
}

DWORD
BIDirect3DVolumeTexture8::SetPriority(DWORD PriorityNew)
{
	this->m_Priority = PriorityNew;
	return m_Priority;
}

HRESULT
BIDirect3DVolumeTexture8::GetLevelDesc(UINT Level, D3DVOLUME_DESC *pDesc)
{
	return D3D_OK;
}

D3DRESOURCETYPE
BIDirect3DVolumeTexture8::GetType()
{
	return D3DRTYPE_VOLUMETEXTURE;	
}

HRESULT
BIDirect3DVolumeTexture8::GetDevice(IDirect3DDevice8 **ppDevice)
{
	*ppDevice = this->m_pDevice;
	return D3D_OK;
}

ULONG
BIDirect3DVolumeTexture8::AddRef()
{
	m_refCount	++;
	return 0;
}