/****************************************************************************
; *
; *     File        : windefs.h
; *
; *     Description : Win32 minimal integration for DirectX Header compilation.
; *                   (Lite version of 'windows.h')
; *
; *     Copyright  Realtech VR 2001
; *
; *     Permission to use, copy, modify, distribute and sell this software
; *     and its documentation for any purpose is hereby granted without fee,
; *     provided that the above copyright notice appear in all copies and
; *     that both that copyright notice and this permission notice appear
; *     in supporting documentation.  Realtech makes no representations
; *     about the suitability of this software for any purpose.
; *     It is provided "as is" without express or implied warranty.
; *
; ***************************************************************************/

#ifndef _CINTERFACE_HH_
#define _CINTERFACE_HH_
#define _WINDOWS_
#include <stdlib.h>
#include <float.h>
#define	S_OK			0
#define	FALSE			0
#define TRUE			1
#define MAKE_HRESULT(sev,fac,code) ((HRESULT) (((unsigned long)(sev)<<31) | ((unsigned long)(fac)<<16) | ((unsigned long)(code))) )
#define interface struct
#define HRESULT	unsigned int
#define APIENTRY __stdcall
#define WINGDIAPI __declspec(dllexport)	  
#define STDMETHODCALLTYPE		__stdcall 
#define STDMETHOD(method)       virtual HRESULT STDMETHODCALLTYPE method
#define STDMETHOD_(type,method) virtual type STDMETHODCALLTYPE method
#define PURE                    = 0
#define THIS_
#define THIS                    void
#define DECLARE_INTERFACE(iface)    interface iface
#define DECLARE_INTERFACE_(iface, baseiface)    interface iface : public baseiface
#define DWORD					long
#define WORD					short
#define INT						int
#define ULONG					unsigned long
#define UINT					unsigned int
#define BOOL					int
#define LONG					long
#define CONST					const
#define	BYTE					unsigned char
#define HWND					void *
#define FLOAT					float
#define LPVOID					void *
#define LPCVOID					void *
#define LPDWORD					DWORD *
#define LPGUID					GUID *
#define	LPCSTR					char *
#define VOID					void
#define	LPSTR					char *
#define	LPWSTR					char *
#define	LPCWSTR					char *
#define LPCTSTR					char *
#define PDWORD					DWORD *
#define PVOID					void *
#define EXTERN_C				extern "C"
#define WINAPI					__stdcall
#define LPGLYPHMETRICSFLOAT		void *
#define	HGLRC					void *
#define DECLARE_HANDLE(type)	typedef DWORD type
#define DEVMODE					void *
#define HDC						DWORD
#define HMONITOR				DWORD
#define HMONITOR_DECLARED
#define LOGFONT					DWORD
#define	HFONT					DWORD
#define HMODULE					DWORD
#define PROC					void *
#define PIXELFORMATDESCRIPTOR	void
#define LPPIXELFORMATDESCRIPTOR	void *
#define TCHAR					char 
#define STDAPI					

class	IStream;
class	pStream;

typedef struct tagRECT
{
    LONG    left;
    LONG    top;
    LONG    right;
    LONG    bottom;
} RECT, *PRECT, *LPRECT;

typedef struct tagPOINT
{
    LONG  x;
    LONG  y;
} POINT, *PPOINT;

typedef struct _RGNDATAHEADER {
    DWORD   dwSize;
    DWORD   iType;
    DWORD   nCount;
    DWORD   nRgnSize;
    RECT    rcBound;
} RGNDATAHEADER, *PRGNDATAHEADER;

typedef struct _RGNDATA {
    RGNDATAHEADER   rdh;
    char            Buffer[1];
} RGNDATA, *PRGNDATA;



#ifndef GUID_DEFINED
#define GUID_DEFINED
typedef struct _GUID
{
    unsigned long Data1;
    unsigned short Data2;
    unsigned short Data3;
    unsigned char Data4[8];
} GUID;

#ifndef INITGUID

#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
	    EXTERN_C const GUID name
#else

#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        EXTERN_C const GUID name \
                = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
#endif // INITGUID

struct PALETTEENTRY;

#endif /* GUID_DEFINED */

#define IID					GUID
#define CLSI				GUID
#define FMTID				GUID

#define REFGUID             const GUID &
#define REFIID              const IID &
#define REFCLSID            const CLSID &
#define REFFMTID            const FMTID &
#define __RPC_FAR	


class IUnknown
{
public:
    virtual HRESULT STDMETHODCALLTYPE QueryInterface( 
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject) = 0;
    
    virtual ULONG STDMETHODCALLTYPE AddRef( void) = 0;
    
    virtual ULONG STDMETHODCALLTYPE Release( void) = 0;

	template <class Q>
	HRESULT STDMETHODCALLTYPE QueryInterface(Q** pp)
	{
#ifdef _MSC_VER
		return QueryInterface(__uuidof(Q), (void**)pp);
#else
		return 0xffffffff;
#endif
	}

};

#endif

